<?php
/*
  $Id: epath.php, v5.00 11/06/2008

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2004 osCommerce

  Released under the GNU General Public License
  Modified to work with Zen Cart on ^/28/2004
*/

  class epath {
    var $code, $title, $description, $enabled;

// class constructor
    function __construct() {
      global $order;

      $this->code = 'epath';
      if ($_GET['main_page'] != '') {
        $this->title = MODULE_PAYMENT_EPATH_TEXT_CATALOG_TITLE; // Payment module title in Catalog
      } else {
        $this->title = MODULE_PAYMENT_EPATH_TEXT_ADMIN_TITLE; // Payment module title in Admin
      }
      $this->description = MODULE_PAYMENT_EPATH_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_EPATH_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_EPATH_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_EPATH_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_EPATH_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = 'https://'
					. MODULE_PAYMENT_EPATH_CODE . 
					'/'
					. MODULE_PAYMENT_EPATH_ID . 
					'/'
					. MODULE_PAYMENT_EPATH_ID . 
					'.php?';
    }

// class methods
    function update_status() {
      global $order, $db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_EPATH_ZONE > 0) ) {
        $check_flag = false;
        $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_EPATH_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while (!$check_query->EOF) {
          if ($check_query['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check_query['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
          $check_query->MoveNext();
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order;
      $process_button_string = zen_draw_hidden_field('ord', time()) .
                               zen_draw_hidden_field('des', "Online Order") .
                               zen_draw_hidden_field('frq', "One Time Only") .
                               zen_draw_hidden_field('opt', "NA") .
  			       zen_draw_hidden_field('ceml', ($order->customer['email_address'])) .
                               zen_draw_hidden_field('amt', "\$" . number_format($order->info['total'], 2)) .
                               zen_draw_hidden_field('ret', zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL'));

      return $process_button_string;
    }

    function before_process() {
      global $messageStack, $order;
      if (!isset($_POST['ord']) || $_POST['ord'] == '') {
        $messageStack->add_session('checkout_payment', MODULE_PAYMENT_EPATH_ERROR, 'error');
        zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
      }
      $_SESSION['ord'] = $_POST['ord'];
      $order->info['comments'] .= sprintf(MODULE_PAYMENT_EPATH_RECEIPT_NUMBER_TEXT, $_SESSION['ord']);
      return $_SESSION['ord'];
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function get_error() {
      return false;
    }

    function check() {
    global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EPATH_STATUS'");
        $this->_check = $check_query->RecordCount();
		      }
		      return $this->_check;
    }

    function install() {
    global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable e-Path Module', 'MODULE_PAYMENT_EPATH_STATUS', 'True', 'Accept credit card payments online securely via the e-Path manual credit card payment gateway?<br>Website: <a href=\"http://e-path.com.au\" target=\"_blank\">http://e-path.com.au</a>', '6', '3', 'zen_cfg_select_option(array(\'True\', \'False\'),', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('E-Path Customer ID', 'MODULE_PAYMENT_EPATH_ID', '', 'Enter your e-Path customer I.D.', '5', '4', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('E-Path Service Code', 'MODULE_PAYMENT_EPATH_CODE', '', 'Enter your e-Path Service Code', '6', '5', now())"); 
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_EPATH_CURRENCY', 'Selected Currency', 'The currency to use for credit card transactions', '6', '6', 'zen_cfg_select_option(array(\'Selected Currency\',\'Only USD\',\'Only AUD\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_EPATH_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_EPATH_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_EPATH_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
    }

    function remove() {
    global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_EPATH_STATUS', 'MODULE_PAYMENT_EPATH_CODE','MODULE_PAYMENT_EPATH_ID', 'MODULE_PAYMENT_EPATH_CURRENCY', 'MODULE_PAYMENT_EPATH_ZONE', 'MODULE_PAYMENT_EPATH_ORDER_STATUS_ID', 'MODULE_PAYMENT_EPATH_SORT_ORDER');
    }
  }
?>
